import { NgModule, NO_ERRORS_SCHEMA } from "@angular/core";
import { NativeScriptModule } from "nativescript-angular/nativescript.module";
import { NativeScriptRouterModule } from "nativescript-angular/router";
import { NativeScriptFormsModule } from "nativescript-angular/forms";
import { CommonModule } from "@angular/common";
import { Routes } from "@angular/router";
import { StartComponent } from "./start/start.component";
import { StartService } from "./start/start.service";

export const routerConfig: Routes = [
    {
        path: "start",
        component: StartComponent, pathMatch: "full"
    },
    
];


@NgModule({
    imports: [
        NativeScriptModule,
        NativeScriptFormsModule,
        NativeScriptRouterModule,
        NativeScriptRouterModule.forChild(routerConfig),
        CommonModule

    ],
    declarations: [
        StartComponent
    ],
    providers: [
        StartService
    ],
    schemas: [
        NO_ERRORS_SCHEMA
    ]
})
/*
Pass your application module to the bootstrapModule function located in main.ts to start your app
*/
export class MainModule {
    constructor(private startService: StartService){}
}