import { Injectable } from '@angular/core';
import { ControllerService } from '../module.controller/controller.service';
import * as settings from 'application-settings';
import { BaseService } from '../module.base/base.service';

@Injectable()
export class ConfigService extends BaseService {

//constructor
//********************************************************************************************************
	constructor(protected controllerService: ControllerService) {
		super(controllerService,'config');
	 }

//********************************************************************************************************
// register for messagecontroller
//********************************************************************************************************

	inbox(msg){
		if(msg.cmd === "getConfig"){
			return this.getConfig(msg.parameter);
		}
		else if(msg.cmd === "setConfig"){
			this.setConfig(msg.parameter);
		}
	}

//********************************************************************************************************
// Class Functions
//********************************************************************************************************
	
//gets a config value, sets a default if empty and provided
//********************************************************************************************************
	private getConfig(msg):any{
		let type: string 		= msg.type;
		let key:string   		= msg.key;
		let defaultValue:any 	= msg.defaultValue;

		switch (type){
			case "string" :{
				if(defaultValue !== null){
					return settings.getString(key, defaultValue);
				}
				else{
					return settings.getString(key);
				}
			}
			case "number" :{
				if(defaultValue !== null){
					return settings.getNumber(key, defaultValue);
				}
				else{
					return settings.getNumber(key);
				}
			}
			case "boolean" :{
				if(defaultValue !== null){
					return settings.getBoolean(key, defaultValue);
				}
				else{
					return settings.getNumber(key);
				}
			}
		}
	}
//sets specific config to provided value
//********************************************************************************************************
	private setConfig(msg){

		let type: string 		= msg.type;
		let key:string   		= msg.key;
		let value:any    		= msg.value;

		switch (type){
			case "string" :{
				settings.setString(key, value);
				break;
			}
			case "number" :{
				settings.setNumber(key, value);
				break;
			}
			case "boolean" :{
				settings.setBoolean(key, value);
				break;
			}
		}
	}

}
