import { Component, OnInit, ElementRef, ViewChild } from '@angular/core';
import { Observable } from "tns-core-modules/data/observable";
import { ControllerService } from './controller.service';
import { Image } from "ui/image";
import { Page } from 'ui/page';
import { Color } from 'color';

var textField = require("ui/text-field"); 

@Component({
	selector: 'controller',
	moduleId: module.id,
	templateUrl: 'controller.component.html',
	styleUrls:['controller.component.css']
})

export class ControllerComponent implements OnInit {
	@ViewChild("stackLayout") stackLayout: ElementRef;
	@ViewChild("para1") para1: ElementRef;
	controller: any[] = [];

	receiver:string;
	cmd:string;
	tfs;
	name:string;
	messageList;
	imageView:Image;

	paramCounter: number; 

	text;

	test: Array<any>

	

	constructor(private controllerService: ControllerService, page: Page) { 
		this.receiver = "";
		this.cmd = "";
		this.paramCounter = 1;
		this.tfs = new Array<any>();
		this.name="";
		this.messageList = new Array<string>();
		page.backgroundColor = new Color("#fafafa");
		this.text = "halloooooo"
		
		this.test = new Array();
		this.test.push("asd1")
		this.test.push("asd2")
		this.test.push("asd3")
		this.test.push("asd4")
		this.test.push("asd5")
		this.test.push("asd1")
		this.test.push("asd2")
		this.test.push("asd3")
		this.test.push("asd4")
		this.test.push("asd5")

		
	 }

	
	ngOnInit() {  
		let messages: string = this.controllerService.callHandler("config",{cmd:"getConfig",parameter:{ type:"string", key:"knownMessages"}});
		if(messages !== undefined){
			let list = messages.split("||");
			list.pop();
			this.messageList = list;
		}
	} 

	addParameter(){
		let tf = new textField.TextField();
		this.paramCounter++;
		tf.hint = "Parameter " + this.paramCounter;
		tf.autocorrect = false;
		let style = `
			margin-top:50px; 

			border-bottom-style: solid;
			border-bottom-width: 3px;
			border-bottom-color: black;	  
    	`;
		
		tf.setInlineStyle(style); 
		tf.autocapitalizationType= "none";
		this.tfs.push(tf);
			

		this.stackLayout.nativeElement.addChild(tf);
	}

	addToList(){
		let paras =this.name + " | " + this.receiver +" | "+ this.cmd +" | " + this.para1.nativeElement.text +" | " ;

		for(let i = 0 ; i<this.tfs.length ; i++){
			console.log(this.tfs[i])
			if(i === this.tfs.length -1){
				paras += this.tfs[i].text;
			}
			else{
				paras += this.tfs[i].text + " | "; 
			}
			
		}

		this.controllerService.callHandler("config", {cmd:"setConfig",parameter:{ type:"string", key:"knownMessages", value:this.controllerService.callHandler("config",{cmd:"getConfig",parameter:{ type:"string", key:"knownMessages"}})+ paras + "||"}});
		this.messageList.push(paras);

	}

	sendMessage(item){
		let tmp = item.split(" | ");
		
		let parameter= "";
		for(let i = 3 ; i<tmp.length;i++){
			if(tmp[i].indexOf("{") !== -1){
				let res: string ="";
				let ges: string =tmp[i];
				let k = ges.substring(0, ges.indexOf(":"));
				ges = ges.replace(k+":", "");
				let vges = ges.substring(1,ges.length -2);
 
				let vgesp = vges.split(",");
				for(let j = 0 ; j < vgesp.length ; j++ ){
					let vGES = vgesp[j].split(":");
					let vk = vGES[0];
					let vv = vGES[1];
					if(j !== vgesp.length-1){
						res+= '"'+vk+'":"'+vv+'",';
					}
					else{
						res+= '"'+vk+'":"'+vv+'"';
					}
					
				}
				parameter+='"'+k+'":{'+res+'}';
			}
			else{
				let temp = tmp[i].split(":");
				let k = '"'+temp[0]+'"';
				let v = '"'+temp[1]+'"';
				parameter += k+":"+v;
			}
			

			if(i !== tmp.length-1){
				parameter += ',' ; 
			}	
		}
		

		this.controllerService.callHandler(tmp[1].trim(), {cmd:tmp[2].trim(), parameter:JSON.parse("{"+parameter+"}")})/*.then((ack)=>{
			console.log(ack);
		}).catch((ack)=>{
			console.log(ack);
		});
		*/
		/*
		this.controllerService.callHandler(tmp[1].trim(), {cmd:tmp[2].trim(), parameter:JSON.parse("{"+parameter+"}")})
		.then((data)=>{
			console.log("kfnlnfsnkdcmnf")
			let image = new Image();
			image.src = data.image;
			this.stackLayout.nativeElement.addChild(image);
		}).catch(err=>{
			console.log(err);
		})
		*/
		
	}

	paraTest(args){
		console.log(args.test);

	}
}