import { Injectable } from '@angular/core';
import { ControllerService } from '../module.controller/controller.service';
import { Dictionary } from './language.dictionary';
import { BaseService } from '../module.base/base.service';

@Injectable()
export class LanguageService extends BaseService {

	//********************************************************************************************************
	// Class Variables
	//********************************************************************************************************
	private dic: Dictionary;
	private lang: string;

	constructor(protected controllerService: ControllerService) {
		super(controllerService,'language');
		
		this.controllerService.callHandler("config", {cmd: "setConfig",parameter:{ key: "appLanguage", value: "de", type:"string"}});
		this.lang = this.controllerService.callHandler("config", {cmd: "getConfig", parameter:{key: "appLanguage", defaultValue: "de", type:"string"}});
		console.log(this.lang)
		this.dic = new Dictionary(this.lang);
	}

	//********************************************************************************************************
	// register for MessageController
	//********************************************************************************************************
	public inbox(msg){
		if(msg.cmd === "getLine"){
			return this.getLine(msg.parameter.number);
		}
	}

	private setLanguage(lang: string){
		this.controllerService.callHandler("config", {cmd: "setConfig",parameter:{ key: "appLanguage", value: lang, type: "string"}});
		this.dic = new Dictionary(lang);
	}

	private getLanguage():string{
		return this.controllerService.callHandler("config", {cmd: "getConfig", parameter:{ key: "appLanguage", defaultValue: "de", type: "string"}});
	}

	getLine(number: number): string{
		return this.dic.getLine(number);
	}

	

}