import { Injectable } from '@angular/core';
import { ControllerService } from '../module.controller/controller.service'

import { Router, NavigationExtras } from "@angular/router";
import { RouterExtensions } from "nativescript-angular/router";
import { ExtendedNavigationExtras } from 'nativescript-angular/router/router-extensions';
import { BaseService } from '../module.base/base.service';


@Injectable()
export class RouterService extends BaseService {

	constructor(protected controllerService : ControllerService,
				private   router			: Router,
				private   routerExtensions	: RouterExtensions) {
		super(controllerService,'router');
	}

	//********************************************************************************************************
	// register for MessageController
	//********************************************************************************************************
	public inbox(msg){
		if(msg.cmd === "navigate"){
			this.navigate(msg.parameter.dest, msg.parameter.transition);
		}
		else if(msg.cmd ==="back"){
			this.goBack();
		}
	}

	navigate(dest, transition?:{name: string, duration: number, curve}, clearHistory: boolean=false){
		if(!transition){
			this.routerExtensions.navigate(["/" + dest]);
		}
		else{
			this.routerExtensions.navigate(["/" + dest], {transition: {
				name: transition.name,
				duration: transition.duration,
				curve: transition.curve 
			}});
		}
	}

	goBack(){
		this.routerExtensions.back();
	}
	
}