import { NgModule, NO_ERRORS_SCHEMA } from "@angular/core";
import { NativeScriptModule } from "nativescript-angular/nativescript.module";
import { NativeScriptRouterModule } from "nativescript-angular/router";
import { NativeScriptFormsModule } from "nativescript-angular/forms";
import { CommonModule } from "@angular/common";
import { Routes } from "@angular/router";
import { ControllerComponent } from "./module.controller/controller.component";
import { ControllerService } from "./module.controller/controller.service";
import { LanguageService } from "./module.language/language.service";
import { ConfigService } from "./module.config/config.service";
import { RouterService } from "./module.router/router.service";



export const routerConfig: Routes = [
    {
        path: "controller",
        component: ControllerComponent, pathMatch: "full"
    },
    
];


@NgModule({
    imports: [
        NativeScriptModule,
        NativeScriptFormsModule,
        NativeScriptRouterModule,
        NativeScriptRouterModule.forChild(routerConfig),
        CommonModule

    ],
    declarations: [
        ControllerComponent
    ],
    providers: [
        ConfigService,
        ControllerService,
        LanguageService,
        RouterService,

    ],
    schemas: [
        NO_ERRORS_SCHEMA
    ]
})
/*
Pass your application module to the bootstrapModule function located in main.ts to start your app
*/
export class ServiceModule {
    constructor(
        private controllerService: ControllerService,
        private configService: ConfigService,
        private languageService: LanguageService,
        private routerService: RouterService
    ){}
}